		#include        p12f1572.inc

                __CONFIG   _CONFIG1, _CLKOUTEN_OFF & _CP_OFF & _BOREN_ON & _MCLRE_OFF & _PWRTE_OFF & _WDTE_ON & _FOSC_INTOSC
                __CONFIG   _CONFIG2, _LVP_OFF & _PLLEN_OFF

        ;Code for Flock PSU
	;                            
        ;********************
        ;Still to do:

		;Tidy up eeprom checksum storage
		;Longer delay before sending image to base?
		
        ;********************
	;
	;Packets in from bluenose: 
	;$GPBLU,aa,n1,n2,n3,n4,n5,n6,n7,aa,NOSE*00
	;aa=packet ID, n1-7=data NOTE packet IDs 1 and 9 are blocked externally
	;
	;Packets out to base:
	;$GPRMC,232224,,,,,,,,171116,A*0c timecode from GPS
	;
	;$GPPSU,aa,n1,n2,n3,n4,n5,n6,n7,aa,A*yy
	;aa=packet ID, n1-9=data
	;01 01 - Movement sensor activated
	;
	;02,01,R1G1,B1R2,G2B2,R3G3,B3R4,G4B4,02 - RGB LEDs 1-4 in flock
	;
	;02,02,R5G5,B5R6,G6B6,R7G7,B7R8,G8B8,02 - RGB LEDs 5-8 in flock
	;
	;02,03,PB17PB16,PB15PB14,PB13PB12,PB12PB11,PB27PB26,PB25PB24,02 - Packetbits1+2 0-ignore, 1-off, 2-on
	;
	;02,04,PB23PB22,PB21PB20,R1G1,B1R2,G2B2,,02 - Packetbits2, Base LED1 LED2
	;
	;02,05,Profile,,,,,,03 - select profile 0-3
	;
	;03,01,HH,MM,SS,DD,MM,YY,03 - Set time (overwritten by GPS)
	;
	;03,02,DimHHon,DimMMon,DimHHoff,DimMMoff,,03 - Set dim on/off times
	;
	;03,03,AlaHH,AlaMM,Alabits,,,03 - Set alarm and switch on/off
	;
	;04,Relay1,Relay2,Relay3,Relay4,Relay5,Relay6,Holdtime,04 - Send Relay bytes to display
	;
	;08,cat1cat2,cat3cat4,cat5cat6,cat7cat8,cat9cat0,,08 - Cathode remap
	;
	;09,EPM,,,,,*xx EEPROM image incoming
	;															
        ;********************
	;	
	;test strings
	;0x13,$GPRMC,232224,,,,,,,,171116,A*0c
	;0x13,$GPBLU,02,11,22,33,44,55,66,77,02,NOSE*00
	;$GPRMC,232224,,,,,,,,171116,A*0c - GPS in
	;$GPPSU,7,1,2,3,4,5,99,2*** - Beacon mode test
	;$GPPSU,8,98,76,54,32,10,0*** - cat remap test
	;$GPPSU,02,02,02,22,44,66,88,AF,**** - LED data test
	;$GPPSU,02,05,02,,,,,,**** - change profile
	;$GPPSU,02,04,0,0,fc,b0,0f,*** - Set PB2 3-0 and base LEDs
	;
	;EEPROM commands:
	;0x13,$GPEepRoM*00 - prepare to receive EEPROM image, sent with 20mS byte delay
	;0x13,$GPEepId*00 - Read and display EEPROM IDs in local memory		
	;
	;To build rom image:
	;Copy .hex file then run
	;hex2bin -l 1000 -w -k 1 -f 000 Flock_PSU.X.production.hex - PSU image
	;
	;hex2bin -l 1000 -w -k 1 -f 000 Base.X.production.hex - Base image
	;
	;this will create a hexfile with checksum bytes at 0x000,0x001
	;Send with a character delay of 20mS
		
;PIN	1	vdd
;PIN	2	RA5	DI	RXD Bluenose
;PIN	3	RA4	DO	TXD Bluenose
;PIN	4	RA3	DI	Radar in
;PIN	5	RA2	DOI	LED2/SDA	
;PIN	6	RA1	DI	RXD 433/SCL
;PIN	7	RA0	DO	TXD Out/LED3
;PIN	8	vss

;-----------------------------                                
;I/O data from OS for user program found from 60-7fh BANK 00000000000000000000000000000000000
;-----------------------------
	
PRBUF			equ	0x20	;PRAM buffer 0x20-0x3f
	
			
VerO			equ	0x4f	;Unlock for IIC writes, must contain 'O'

VerK			equ	0x67	;Unlock for IIC writes, must contain 'K'			
EEID			equ	0x68	;eeprom ID byte
EEID1			equ	0x69	;eeprom ID byte ASCII 1
EEID2			equ	0x6a	;eeprom ID byte ASCII 2
CalcsumL		equ	0x6c	;Calculated EEPROM checksum LSB
CalcsumH		equ	0x6d	;Calculated EEPROM checksum MSB
EEsumL			equ	0x6e	;Retrieved EEPROM checksum LSB
EEsumH			equ	0x6f	;Retrieved EEPROM checksum MSB
	
UTL			equ	0x70	;IIC address pointer LSB
UTM			equ	0x71	;IIC pointer MSB
GPSCH			equ	0x72	;checksum MSN
GPSCL			equ	0x73	;checksum LSN
Tcount			equ	0x74	;Number of transmits in a row
DVAR			equ	0x75	;Delay counter
DVAR2			equ	0x76	;Delay counter
GPStemp1		equ	0x77	;temp buffer for GPS data
IICC			equ	0x78	;temp buffer for GPS data
		
IICtemp			equ	0x79	;temp data holder for IIC
GPStemp4		equ	0x7a	;temp buffer for checksum data		
Tick			equ	0x7b	;1/250 sec tick
Seck			equ	0x7c	;Seconds
TempCounP1a		equ	0x7d	;Temp counter for timeout
INTflags		equ	0x7e	;Software flag Bit 7 - GPS data string ready
					;Software flag Bit 6 - GPS string being received
					;Software flag Bit 5 - Movement sensor activated
					;Software flag Bit 4 - BT data detected and not timed out
					;Software flag Bit 3 - Set every second
					;Software flag Bit 2 - EEPROM receive mode activated
					;Software flag Bit 1 - 
					;Software flag Bit 0 - 
GPSpoint		equ	0x7f	;Pointer for GPS data buffer

;#########################################################################################################
;						START OF CODE
;#########################################################################################################

				org 0x00	;Code here is permanent - used for bootstrap loaders etc.
		goto	0x10			;Reset vector
		nop

	dt  "PS"	    ;EEPROM ID PS CL BA

				org 0x04
		banksel	PORTA

		btfsc	PIR1,5
		goto	GPSRXD			;RXD from IR/GPS

		btfsc	PIR1,1
		goto	Timr6			;Timer 2 Interrupt - RTC

		btfsc	INTCON,IOCIF
		goto	IntOC			;data detected on RA5		
		retfie						
	
;****************************************************************************************************
				org 0x10	;THIS CANNOT MOVE WILL BREAK EEPROM BACKUP
Inity						;Initialise registers
		clrwdt
		bcf	INTCON,7
;Coldstart
		movlw	0x20
		movwf	FSR0H
		clrf	FSR0L
Init1
		clrf	INDF0
		incfsz	FSR0L,f
		goto	Init1
		clrf	PORTA
		call	DonesendNAME

;------------------------------------------------------------
;Warmstart
;Set I/O pins
		BANKSEL	OSCCON
		movlw	b'01111000'
		movwf	OSCCON
;Set ADC controls
		BANKSEL	ANSELA
		clrf	ANSELA			;Weird DO fault?

		BANKSEL	TRISA
		movlw	b'11101010'
		movwf	TRISA

		movlw	b'00000100'
		movwf	OPTION_REG		;Timer 0 1:32 prescaler

		BANKSEL	WPUA
		movlw	b'10000100'
		movwf	WPUA			;no pullups
		
		;BANKSEL	RCSTA
		;BCF	RCSTA,4			;Switch off serial port

		BANKSEL	PORTA
;Setup Timer2
		movlw	b'00001111'		;T2 on, 1:1 prescaler
		movwf	T2CON
		BANKSEL	PIE1
		bsf	PIE1,1
		BANKSEL	TMR2
		movlw	.250
		movwf	TMR2
		bsf	INTCON,PEIE		;Interrupts enabled
		
;Setup RXD for GPS data
		BANKSEL	APFCON
		movlw	b'00000000'		;GPS/Base - RXD on ra1,TXD on RA0
		;movlw	b'10000100'		;Bluetooth - RXD on ra5,TXD on RA4
		movwf	APFCON			;Force bluetooth receive
		BANKSEL	BAUDCON
		movlw	.103;25			;2400=103, 9600=25
		movwf	SPBRGL	
		movlw	b'10010000'		;Enable serial, no TXD
		movwf	RCSTA
		nop
		bsf	TXSTA,5
		
		BANKSEL	PIE1
		bsf	PIE1,5			;Enable RXD interrupts
		BANKSEL	PCON
		bsf	PCON,1			;Set Power on flag
		
		bsf	INTCON,IOCIE
		BANKSEL	IOCAN
		bsf	IOCAN,5			;Set RA5(BT rxd) as int on neg change
		
		BANKSEL	ANSELA
		clrf	ANSELA			;Weird DO fault?
		
		BANKSEL	PORTA	
		bsf	INTCON,GIE	
		call	longerdel
		call	longerdel
		call	longerdel
		call	longerdel
		
		call	BLUsend
		goto	MainStart
			
;--------------------------------------------------------------------------------------------------------
IICread					;
;--------------------------------------------------------------------------------------------------------

		bcf	INTCON,7
		call	IICreadRaw
		bsf	INTCON,7
		return
IICreadRaw	
		BANKSEL	PORTA
		call	InitIIC			;Setup bus for atart, disable INTS
		movlw	b'10100000'		;24c64 address, read (bit 0 clear)
		call	IICout
		call	NACK			;Send ACK
		movf	UTM,w			;Address MSB
		call	IICout
		call	NACK			;Send ACK
		movf	UTL,w			;Address LSB
		call	IICout
		call	NACK			;Send ACK	
		call	NRESTART
		
		movlw	b'10100001'		;24c64 address, read (bit 0 clear)
		call	IICout
		call	NACK			;Send ACK
		call	NIN
		call	IICinin			;read byte
		movwf	IICC
		call	NSTOP			;Set STOP
		goto	IICexit			;Restore interrupts

;--------------------------------------------------------------------------------------------------------
IICwrite				;
;--------------------------------------------------------------------------------------------------------

		bcf	INTCON,7
		call	IICwriteRaw
		bsf	INTCON,7
		return
IICwriteRaw
		BANKSEL	PORTA
		movlw	"O"			;Check write unlock
		xorwf	VerO,w
		btfss	STATUS,Z
		return
		
		movlw	"K"			;Check write unlock
		xorwf	VerK,w
		btfss	STATUS,Z
		return
	
		call	InitIIC			;Setup bus for atart, disable INTS
		movlw	b'10100000'		;24c64 address, read (bit 0 clear)
		call	IICout
		call	NACK			;Send ACK
		movf	UTM,w			;Address MSB
		call	IICout
		call	NACK			;Send ACK
		movf	UTL,w			;Address LSB
		call	IICout
		call	NACK			;Send ACK
		
		movf	IICC,w
		call	IICout			;Send byte in IICC to EEPROM	
		call	NACK			;Send ACK	
		call	NSTOP			;Set STOP
		clrf	VerO
		clrf	VerK
		
		movlw	.20
		movwf	DVAR2
		call	d0			;EEPROM Write delay
		
		goto	IICexit			;Restore interrupts

;--------------------------------------------------------------------------------------------------------
						;IIC IO routines
;--------------------------------------------------------------------------------------------------------

lildel
		nop
		nop
		nop
		return
InitIIC
		BANKSEL	TRISA
		bcf	PORTA,1			;SCL out
		BANKSEL	PORTA			;Setup bus start
		bsf	PORTA,2			;SDA high
		call	lildel
		bsf	PORTA,1			;SCL high
		BANKSEL	TRISA
		bcf	PORTA,2			;SDA out
		bcf	PORTA,1			;SCL out
		BANKSEL	PORTA

		bcf	PORTA,2			;SDA low
		call	lildel
		bcf	PORTA,1			;SCL low
		return
IICout						;Send byte in W to IIC
		movwf	IICtemp
		movlw	.8
		movwf	DVAR
IICoutout

		btfsc	IICtemp,7
		goto	IICoutout1	
		bcf	PORTA,2
		goto	IICoutout2
IICoutout1
		bsf	PORTA,2
IICoutout2
		call	lildel
		bsf	PORTA,1			;SCL high
		call	lildel
		bcf	PORTA,1			;SCL low
		call	lildel
		lslf	IICtemp,f	
		decfsz	DVAR,f
		goto	IICoutout
		bcf	PORTA,2			;SDA low
		return
IICinin						;read byte from IIC, return in IICtemp and W
		BANKSEL	PORTA
		movlw	.8
		movwf	DVAR
IICininin
		lslf	IICtemp,f
		bsf	PORTA,1			;SCL high
		call	lildel
		bsf	IICtemp,0
		btfss	PORTA,2	
		bcf	IICtemp,0
		bcf	PORTA,1			;SCL low
		call	lildel
		decfsz	DVAR,f
		goto	IICininin
		bsf	PORTA,2			;SDA high

		BANKSEL	TRISA
		bcf	PORTA,2			;SDA out
		BANKSEL	PORTA
		movf	IICtemp,w		;Move byte to W
		return
NACK	
		bcf	PORTA,2			;SDA low
		call	lildel
		bsf	PORTA,1			;SCL high
		call	lildel
		bcf	PORTA,1			;SCL low
		call	lildel
		return
NIN						;Set for data in
		BANKSEL	TRISA
		bsf	TRISA,2
		BANKSEL	PORTA
		return
NSTOP						;Set stop condition
		bcf	PORTA,2			;SDA low
		call	lildel
		bsf	PORTA,1			;SCL high
		call	lildel
		bsf	PORTA,2			;SDA high
		call	lildel
		return
NRESTART
		bsf	PORTA,2			;SDA high
		call	lildel
		bsf	PORTA,1			;SCL high
		call	lildel
		bcf	PORTA,2			;SDA low
		call	lildel
		bcf	PORTA,1			;SCL low
		return		
IICexit
		BANKSEL	TRISA
		bsf	PORTA,1			;SCL restored to in
		BANKSEL	PORTA	
		return

;--------------------------------------------------------------------------------------------------------		
EEnewrestore					;Copy new eprom into PRAM and reboot
;--------------------------------------------------------------------------------------------------------				
		
		bcf	INTflags,2
		call	BurnNAMEsend		;Send 'updating' message			
		bcf	INTCON,7
		movlw	0x04;04
		movwf	UTM			;Point to LOW eeprom image, 0200-
		clrf	UTL
EEnewrestore1	
		clrf	FSR0L
		movf	UTM,w
		call	PRAMwipe
		call	PRAMwrite		;Write 32 bytes to program eeprom	
		movf	UTM,w
		incf	UTL,f
		decfsz	UTL,f
		goto	EEnewrestore1
		incf	UTM
		movlw	0x10			
		xorwf	UTM,w
		btfss	STATUS,Z		;0x10?
		goto	EEnewrestore1
		call	DonesendNAME
		reset
		
;--------------------------------------------------------------------------------------------------------
		
PRAMwrite					;Write block of 32 bytes (16 words) at INDF1
		BANKSEL	PMADRL
		lsrf	UTM,w
		movwf	PMADRH
		rrf	UTL,w
		movwf	PMADRL
		bsf	PMADRH,7			;Convert UTM,L to program rom address
		clrf	FSR0L
		bcf	PMCON1,CFGS
		bsf	PMCON1,WREN
		bsf	PMCON1,LWLO
PRAMwrite1	
		BANKSEL	PORTA
		call	IICreadRaw
		movf	IICC,w
		BANKSEL	PMADRL
		movwf	PMDATH
		incf	UTL,f
		incf	FSR0L,f
		BANKSEL	PORTA
		call	IICreadRaw
		movf	IICC,w
		BANKSEL	PMADRL
		movwf	PMDATL
		incf	UTL,f
		incf	FSR0L,f
		btfsc	FSR0L,5
		goto	PRAMwrite2
		call	PRAMen
		incf	PMADRL,f
		goto	PRAMwrite1
			
PRAMwrite2
		bcf	PMCON1,LWLO
		call	PRAMen
		bcf	PMCON1,WREN
		return
			
PRAMwipe					;Erase block at INDF1
		BANKSEL	PMADRL
		
		lsrf	UTM,w
		movwf	PMADRH
		rrf	UTL,w
		movwf	PMADRL
		bsf	PMADRH,7

		bcf	PMCON1,CFGS
		bsf	PMCON1,FREE
		bsf	PMCON1,WREN
		
		call	PRAMen
		bcf	PMCON1,WREN
		return
		
PRAMen		
		movlw	0x55
		movwf	PMCON2
		movlw	0xaa
		movwf	PMCON2
		bsf	PMCON1,WR
		nop
		nop
		return
		
FirmTB
		BANKSEL	BAUDCON			;send byte in W to BT serial out		
		movwf	TXREG
		nop
BLUR5zll	btfss	TXSTA,1
		goto	BLUR5zll
		BANKSEL	PORTA
		return
		
;--------------------------------------------------------------------------------------------------------
longdel			                        ;Delay loops
;--------------------------------------------------------------------------------------------------------
		
		movlw   0xff	
		movwf	DVAR2
d0
		movlw   0xff
		movwf   DVAR
		clrwdt
		nop
		nop
d1
		decfsz  DVAR,F
		goto    d1
		decfsz  DVAR2,F
		goto    d0
		return
	
longerdel
		call	longdel
		call	longdel
		call	longdel
		call	longdel
		return

;--------------------------------------------------------------------------------------------------------
BurnID						;Read eeprom ID strings
;--------------------------------------------------------------------------------------------------------
	
		movlw	0x04
		call	BurnIDID		;Low image
		;movlw	0x14
		;call	BurnIDID		;High image
		movlw	.10
		call	FirmTB
		movlw	.13
		call	FirmTB
		call	ENAMEsend
		goto	FirmExitHi	
		
BurnIDID		
		movwf	UTM
		movlw	0x01
		movwf	UTL		
				
		call	IICread
		movlw	"$"			;is there a "$" string marker?
		xorwf	IICC,w
		btfss	STATUS,Z			
		goto	BurnIDfail1		;NO
		
		movlw	.10
		call	FirmTB
		movlw	.13
		call	FirmTB
		movlw	.19			;Point to 'PSU' part of ID
		movwf	UTL
		
BurnIDloop1	
		call	IICread
		movf	IICC,w
		call	FirmTB
		incf	UTL,f
		incf	UTL,f
		movlw	0x21			;All bytes read?
		xorwf	UTL,w
		btfss	STATUS,Z			
		goto	BurnIDloop1
		return

BurnIDfail1
		movlw	HIGH EEmisssend		;Transmit string
		movwf	FSR0H
		movlw	LOW EEmisssend
		movwf	FSR0L
		call	BLUpacket		;Send string
		return	
EEmisssend
	dt  0x0d,0x0a,"ID missing",0x0d,0x0a,0xff    ;EEPROM ID error string

;--------------------------------------------------------------------------------------------------------
Timr6						;Timer 1 interrupt, set 1/100 flag
;--------------------------------------------------------------------------------------------------------

		clrwdt
		incf	Tick,f
		movlw	.254
		xorwf	Tick,w
		btfss	STATUS,Z
		goto	mainsexit
		clrf	Tick

		incf	Tcount,f
		decfsz	Tcount,f		;Check if zero, skip if so
		goto	Timr6b
		goto	Timr6a	
Timr6b
		decfsz	Tcount,f		;Check if not zero, skip if so
		goto	Timr6a
		BANKSEL	PORTA
		bcf	PORTA,2			;Just timed out, clear regs
		bsf	INTCON,7
		bcf	INTflags,2		;Clear eeprom mode - timed out
		bcf	INTflags,4
		bsf	INTCON,IOCIE		;enable IOCs for next BT packet
		
		BANKSEL	APFCON
		movlw	b'00000000'		;GPS/Base - RXD on ra1,TXD on RA0
		;movlw	b'10000100'		;Bluetooth - RXD on ra5,TXD on RA4
		btfss	INTflags,2		;Don't reset to GPS if EE receive active
		movwf	APFCON			;Force GPS receive
		BANKSEL	BAUDCON			;setup serial 9600bps
		movlw	.103			;2400=103, 9600=26
		btfss	INTflags,2		;Don't reset baud rate if EE receive active
		movwf	SPBRGL
		BANKSEL	PORTA
			
Timr6a		
		incf	Seck,f
		bsf	INTflags,3
		
		btfsc	INTflags,2
		goto	mainsexit		;Exit if receiving eeprom image
		
		bcf	INTflags,5
		btfsc	PORTA,3
		bsf	INTflags,5		;Check movement sensor and set bit if active
		
mainsexit					;Reload counter for next interrupt
		bcf	PIR1,1 			;clear timer 1 int
		retfie
		
;--------------------------------------------------------------------------------------------------------
IntOC						;INT on change, BT data detected
;--------------------------------------------------------------------------------------------------------

		clrwdt
		bcf	INTCON,IOCIF
		BANKSEL	IOCAF
		bcf	IOCAF,5
		btfsc	INTflags,2
		retfie				;Exit if receiving eeprom image
		
		bcf	INTCON,IOCIE		;Disable more pin iocs for now
		BANKSEL	PORTA
		movlw	.3
		movwf	Tcount
		bsf	INTflags,4
		bcf	INTflags,7		;Flush incoming data buffer
		bcf	INTflags,6
		
		BANKSEL	BAUDCON			;setup serial 9600bps
		movlw	.26			;2400=103, 9600=26
		movwf	SPBRGL
		BANKSEL	APFCON
		;movlw	b'00000000'		;GPS/Base - RXD on ra1,TXD on RA0
		movlw	b'10000100'		;Bluetooth - RXD on ra5,TXD on RA4
		movwf	APFCON			;Force bluetooth receive
		BANKSEL	PORTA
		retfie	
	
;--------------------------------------------------------------------------------------------------------
ENAMEsend					;Send eeprom version label		
;--------------------------------------------------------------------------------------------------------
	
		movlw	HIGH EEname		;Transmit string
		movwf	FSR0H
		movlw	.9			;Start of 'PSU101' section of ID
		movwf	FSR0L
		call	BLUpacket		;Send string		
		return
		
;--------------------------------------------------------------------------------------------------------		
EEinvNAMEsend					;Send 'Incorrect image'
;--------------------------------------------------------------------------------------------------------
		
		movlw	HIGH EEinvsend		;Transmit string
		movwf	FSR0H
		movlw	LOW EEinvsend
		movwf	FSR0L
		call	BLUpacket		;Send string
		return			
EEinvsend
	dt  0x0d,0x0a,"Image not written",0xff			
	
;--------------------------------------------------------------------------------------------------------		
DonesendNAME					;Send 'Done'
;--------------------------------------------------------------------------------------------------------
		
		movlw	HIGH Donesend		;Transmit string
		movwf	FSR0H
		movlw	LOW Donesend
		movwf	FSR0L
		call	BLUpacket		;Send string
		return
Donesend
	dt  0x0d,0x0a,"Done",0xff
	
;--------------------------------------------------------------------------------------------------------		
BurnNAMEsend					;Send 'Write eeprom'
;--------------------------------------------------------------------------------------------------------
		
		movlw	HIGH EEBURNsend		;Transmit string
		movwf	FSR0H
		movlw	LOW EEBURNsend
		movwf	FSR0L
		call	BLUpacket		;Send string
		return		
EEBURNsend
	dt  0x0d,0x0a,"Firmware update, please wait.",0xff	    ;EEPROM update end string

		
;#########################################################################################################
;#########################################################################################################
;#########################################################################################################
;#########################################################################################################
				
	org 0x0200				;Code from here is updateable
	
EEname		
	dt  "$GPEEPROMPSU0101",0xff		;.bin code identifier with version and release numbering
			
GPSRXD
		goto	GPSRXDHi		;Jump points for updated adresses
BLUsend
		goto	BLUsendHi
MainStart		
		goto	MainStartHi
SENDrelay
		goto	SENDrelayHi
BLUpacket
		goto	BLUpacketHi
GPSdecodeX
		goto	GPSdecodeXHi		
FirmExitHi
		goto	FirmExit
					
;--------------------------------------------------------------------------------------------------------
MainStartHi					;Refresh display loop and menu - everything else on interrupts
;--------------------------------------------------------------------------------------------------------

		call	checkk
		goto	MainStartHi
		
;--------------------------------------------------------------------------------------------------------
checkk						;Check INTflags
;--------------------------------------------------------------------------------------------------------

		btfsc	INTflags,4		;Check flag for BT data in
		call	CallBT
		btfsc	INTflags,3		;Check flag to call once a second
		call	Call1
		btfsc	INTflags,7		;Check if GPS data received
		call	GPSdecode
		return
		
;--------------------------------------------------------------------------------------------------------
FirmUp						;Enter eeprom receive/store loop
;--------------------------------------------------------------------------------------------------------
		
		bcf	INTflags,7		;Clear check if GPS data received
		bsf	INTCON,IOCIE		;enable IOCs for next BT packet
		call	EEupNAMEsend		;Tell bluetooth we have a valid GPRMC packet
		BANKSEL	PORTA
		clrf	UTM
		clrf	UTL			;EEPROM pointers
		movlw	0x10
		movwf	CalcsumH
		movlw	0x28
		movwf	CalcsumL		;checksum byte preload with first 2 bytes	
		
FirmLoop1					;Byte 0000
		btfss	INTflags,2		;Check if timed out yet
		goto	FirmExit
		btfss	INTflags,1		;Check if byte received yet
		goto	FirmLoop1
		movf	GPStemp1,w		;get rxd
		movwf	EEsumL			;First byte of image,save as checksum
		bcf	INTflags,1
		clrf	IICC			;and replace with 0xFF for now
		decf	IICC
		movlw	'O'
		movwf	VerO
		movlw	'K'
		movwf	VerK
		call	IICwrite
		incf	UTL,f		
FirmLoop2					;Byte 0001
		btfss	INTflags,2		;Check if timed out yet
		goto	FirmExit
		btfss	INTflags,1		;Check if byte received yet
		goto	FirmLoop2
		movf	GPStemp1,w		;get rxd
		movwf	EEsumH			;Second byte of image,save as checksum
		bcf	INTflags,1
		clrf	IICC
		movlw	'O'
		movwf	VerO
		movlw	'K'
		movwf	VerK
		call	IICwrite
		incf	UTL,f		
FirmLoop					;0002-0fff saved here
		btfss	INTflags,2		;Check if timed out yet
		goto	FirmExit
		btfss	INTflags,1		;Check if byte received yet
		goto	FirmLoop		
		movf	GPStemp1,w		;get rxd
		movwf	IICC	
		bcf	STATUS,C		;Add bytes to checksum
		btfss	UTL,0			;Is address even? add to CalcsumL
		addwf	CalcsumL,f
		btfsc	STATUS,C
		incf	CalcsumH,f
		btfsc	UTL,0			;Is address odd? add to CalcsumH
		addwf	CalcsumH,f
		bcf	INTflags,1
		movlw	'O'
		movwf	VerO
		movlw	'K'
		movwf	VerK
		call	IICwrite	
		movlw	.4
		movwf	Tcount			;Extend timeout count
		incf	UTL,f				
		incf	UTL,f
		decfsz	UTL,f
		goto	FirmLoop
		incf	UTM,f	
		movlw	0x10			;Up to 0x1000 yet?
		xorwf	UTM,w
		btfss	STATUS,Z			
		goto	FirmLoop

		BANKSEL	PORTA
		
		
				
		movf	CalcsumH,w		;Compare checksum bytes
		subwf	EEsumH,f
		incf	EEsumH,f
		decfsz	EEsumH,f
		goto	FirmFail		;Checksum fail - received data mismatch
		movf	CalcsumL,w
		subwf	EEsumL,f
		incf	EEsumL,f
		decfsz	EEsumL,f
		goto	FirmFail		;Checksum fail		
		call	CKNAMEsend		;Checksum matched
		movf	CalcsumL,w
		movwf	EEsumL
		movf	CalcsumH,w
		movwf	EEsumH			;Restore checksum for next stage
		movlw	0x10
		movwf	CalcsumH
		movlw	0x28
		movwf	CalcsumL		;Preload with first 2 bytes of ROM
		
		clrf	UTM			;Now verify the saved image is OK
		clrf	UTL			;EEPROM pointers
		incf	UTL,f
		incf	UTL,f
FirmVLoop
		call	IICread
		movf	IICC,w
		bcf	STATUS,C		;Add bytes to checksum
		btfss	UTL,0			;Is address even? add to CalcsumL
		addwf	CalcsumL,f
		btfsc	STATUS,C
		incf	CalcsumH,f
		btfsc	UTL,0			;Is address odd? add to CalcsumH
		addwf	CalcsumH,f
		incf	UTL,f
		incf	UTL,f
		decfsz	UTL,f
		goto	FirmVLoop
		incf	UTM,f
		movlw	0x10			;Up to 0x1000 yet?
		xorwf	UTM,w
		btfss	STATUS,Z				
		goto	FirmVLoop
		
		movf	CalcsumH,w		;Compare checksum bytes
		subwf	EEsumH,f
		incf	EEsumH,f
		decfsz	EEsumH,f
		goto	FirmFail		;Checksum fail - saved data mismatch
		movf	CalcsumL,w
		subwf	EEsumL,f
		incf	EEsumL,f
		decfsz	EEsumL,f
		goto	FirmFail		;Checksum fail
		call	CKNAMEsend		;Checksum OK
	
		clrf	UTM
		clrf	UTL			;EEPROM pointers
		
		movf	CalcsumL,w		;Now save checksum with eeprom data at 0,1
		movwf	IICC
		movlw	'O'
		movwf	VerO
		movlw	'K'
		movwf	VerK
		call	IICwrite
		incf	UTL,f
		;movlw	.20
		;movwf	DVAR2
		;call	d0			;EEPROM Write delay
		movf	CalcsumH,w			
		movwf	IICC
		movlw	'O'
		movwf	VerO
		movlw	'K'
		movwf	VerK
		call	IICwrite
				
		BANKSEL	PORTA
		clrf	UTM
		movlw	.5			;Now ID the eeprom type and store in EEID
		movwf	UTL
		call	IICread	
		movf	IICC,w
		movwf	EEID1
		movlw	.7			;Now ID the eeprom type and store in EEID
		movwf	UTL
		call	IICread	
		movf	IICC,w
		movwf	EEID2
		
		movlw	"P"
		xorwf	EEID1,w
		btfss	STATUS,Z
		goto	Firmnotpsu	
		movlw	"S"
		xorwf	EEID2,w
		btfss	STATUS,Z
		goto	Firmnotpsu
		movlw	.1
		movwf	EEID			;1 = PSU EEPROM
		call	EEpsuNAMEsend
		goto	EEnewrestore		;Write EEPROM to PRAM and restart
		
Firmnotpsu		
		movlw	"C"
		xorwf	EEID1,w
		btfss	STATUS,Z
		goto	Firmnotclk	
		movlw	"L"
		xorwf	EEID2,w
		btfss	STATUS,Z
		goto	Firmnotclk
		movlw	.3
		movwf	EEID			;3 = CLK EEPROM
		call	EEclockNAMEsend
		goto	FirmExitX
		
Firmnotclk		
		movlw	"B"
		xorwf	EEID1,w
		btfss	STATUS,Z
		goto	Firmnotnot	
		movlw	"A"
		xorwf	EEID2,w
		btfss	STATUS,Z
		goto	Firmnotnot
		movlw	.2
		movwf	EEID			;2 = BASE EEPROM
		call	EEbaseNAMEsend
		goto	FirmExitX
		
Firmnotnot		
		call	EEIDDUDsendNAME
		goto	FirmExit
		
FirmFail					;Checksum failed
		call	CKFNAMEsend
		goto	FirmExit
		
FirmExitX	
		call	EEsendNAMEsend		;Message sending to base
		bcf	INTCON,7
		;bsf	INTflags,2
		BANKSEL	APFCON
		movlw	b'00000000'		;GPS/Base - RXD on ra1,TXD on RA0
		
		;movlw	b'10000100'		;Bluetooth - RXD on ra5,TXD on RA4;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
		
		movwf	APFCON	
		BANKSEL	BAUDCON			;setup serial 9600bps
		movlw	.206			;1200=206, 2400=103, 9600=26[;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		movwf	SPBRGL
		BCF	RCSTA,4			;Switch off serial port
		BANKSEL	PORTA
		
		movlw	0x30
		addwf	EEID,w
		movwf	DVAR2
		movlw	"9"
		movwf	DVAR
		call	SENDrelay	
		call	longerdel	
		clrf	UTM			
		clrf	UTL
FirmSend					;Send uploaded eeprom on to base
		call	IICreadRaw
		movf	IICC,w
		call	FirmTB		
		movlw	.100
		movwf	DVAR2
		call	d0			;Poky little delay loop	
		incfsz	UTL,f
		goto	FirmSend
		incf	UTM,f
		movlw	0x10			
		xorwf	UTM,w
		btfss	STATUS,Z		;0x10?
		goto	FirmSend	
			
FirmExit	
		BANKSEL	BAUDCON			;setup serial 9600bps
		movlw	.103;.26		;2400=103, 9600=26[[[[[[[[[[[[[[[[[[[[[[[[[[[[
		movwf	SPBRGL
		BSF	RCSTA,4			;Switch on serial port;;;;;;;;;;;;;;;;;;;;;;;
		BANKSEL	PORTA
		bsf	INTCON,7
		bcf	INTflags,2		;Clear eeprom receive mode
		bcf	PORTA,2	
		call	DonesendNAME
		goto	GPSdecodeX
		
;--------------------------------------------------------------------------------------------------------
GPSRXDHi						;Read incoming RXD byte from GPS
;--------------------------------------------------------------------------------------------------------
					
		BANKSEL	RCREG
		movf	RCREG,w
		BANKSEL	PORTA
		movwf	GPStemp1
		bsf	INTflags,1		;Flag byte received
		btfsc	INTflags,2		;Check flag for EEPROM in
		goto	GPSRXDex		;Exit without using if EEPROM receive active
		bcf	INTflags,1
		
		andlw	0x1f
		movwf	GPStemp4
		btfsc	INTflags,7		;Exit if string ready to process
		goto	GPSRXDex
		btfsc	INTflags,6		;bypass if already receiving a string
		goto	GPSRXDin		

		movlw	"$"			;Look for start byte
		xorwf	GPStemp1,w
		btfss	STATUS,Z
		goto	GPSRXDex		;Not start,exit	
		
		movlw	.80;.0	
		movwf	GPSpoint		;Setup buffer pointer
		bsf	INTflags,6		;Flag string to receive
		goto	GPSRXDex		;Exit ready to receive on next byte

GPSRXDin
		movlw	0x20
		movwf	FSR0H
		movf	GPSpoint,w
		movwf	FSR0L
		movf	GPStemp1,w
		movwf	INDF0
		incf	GPSpoint,f
		movlw	.200			;Look for start byte
		xorwf	GPSpoint,w
		btfsc	STATUS,Z
		goto	GPSRXDerrr		;No stop before end of buffer, discard data and reset

		decf	FSR0L,f
		decf	FSR0L,f
		movf	INDF0,w
		movwf	GPStemp1
		movlw	"*"			;Look for end byte
		xorwf	GPStemp1,w
		btfss	STATUS,Z
		goto	GPSRXDex;3		;No stop byte, exit.
		bcf	INTflags,6		;Clear data being received flag
		bsf	INTflags,7		;Replace with data ready flag
		bcf	INTflags,4		;Clesr BT packet force just in case		
		goto	GPSRXDex
GPSRXDerrr					;Buffer pointer overflowed with no * detected
		bcf	INTflags,7
		bcf	INTflags,6

GPSRXDex
		BANKSEL	PORTA
		bcf	PIR1,5
		retfie		
		
;--------------------------------------------------------------------------------------------------------
Call1						;Run once a sec
;--------------------------------------------------------------------------------------------------------

		bcf	INTflags,3		
Call1a
		btfss	INTflags,5
		return
		bcf	INTflags,5
		call	MOVErelay
		return
		
;--------------------------------------------------------------------------------------------------------
CallBT						;
;--------------------------------------------------------------------------------------------------------
		
		BANKSEL	BAUDCON			;setup serial 9600bps
		movlw	.26			;2400=103, 9600=26
		movwf	SPBRGL	
		BANKSEL	APFCON
		;movlw	b'00000000'		;GPS/Base - RXD on ra1,TXD on RA0
		movlw	b'10000100'		;Bluetooth - RXD on ra5,TXD on RA4
		movwf	APFCON			;Force bluetooth receive
		BANKSEL	PORTA
CallBT1
		btfsc	INTflags,4
		goto	CallBT1
		return
	
;--------------------------------------------------------------------------------------------------------		
BASErelay					;Build the string for base unit and send
;--------------------------------------------------------------------------------------------------------
		
		movlw	0x20
		movwf	FSR0H
		movwf	FSR1H
		movlw	.90;0x0a
		movwf	FSR0L			;Set to point after time data
		movlw	.210
		movwf	FSR1L
		
		movlw	0x08
		movwf	TempCounP1a		;count ,s
BASEdecodeloop					;Now look for the date data
		incf	FSR0L,f
		movlw	","
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BASEdecodeloop		;Not the comma, looop
		decfsz	TempCounP1a,f
		goto	BASEdecodeloop		;Not the LAST comma, looop
		incf	FSR0L,f	
		
		movf	INDF0,w
		movwf	INDF1
		incf	FSR0L,f		
		incf	FSR1L,f		
		
		movf	INDF0,w
		movwf	INDF1
		incf	FSR0L,f		
		incf	FSR1L,f	
		
		movf	INDF0,w
		movwf	INDF1
		incf	FSR0L,f		
		incf	FSR1L,f	
		
		movf	INDF0,w
		movwf	INDF1
		incf	FSR0L,f		
		incf	FSR1L,f	
		
		movf	INDF0,w
		movwf	INDF1
		incf	FSR0L,f		
		incf	FSR1L,f	
		
		movf	INDF0,w
		movwf	INDF1
		incf	FSR0L,f		
		incf	FSR1L,f			;6 bytes of date moved
		
		movlw	.92;.12
		movwf	FSR0L			;Set to point after time data
		
		movlw	","	
		movwf	INDF0
		incf	FSR0L,f		
		movwf	INDF0
		incf	FSR0L,f	
		movwf	INDF0
		incf	FSR0L,f	
		movwf	INDF0
		incf	FSR0L,f	
		movwf	INDF0
		incf	FSR0L,f	
		movwf	INDF0
		incf	FSR0L,f	
		movwf	INDF0
		incf	FSR0L,f	
		movwf	INDF0
		incf	FSR0L,f	
		movlw	.210
		movwf	FSR1L
		
		movf	INDF1,w
		movwf	INDF0
		incf	FSR0L,f		
		incf	FSR1L,f			
		
		movf	INDF1,w
		movwf	INDF0
		incf	FSR0L,f		
		incf	FSR1L,f	
		
		movf	INDF1,w
		movwf	INDF0
		incf	FSR0L,f		
		incf	FSR1L,f	
		
		movf	INDF1,w
		movwf	INDF0
		incf	FSR0L,f		
		incf	FSR1L,f	
		
		movf	INDF1,w
		movwf	INDF0
		incf	FSR0L,f		
		incf	FSR1L,f	
		
		movf	INDF1,w
		movwf	INDF0
		incf	FSR0L,f	
		
		movlw	","	
		movwf	INDF0
		incf	FSR0L,f	
		
		movlw	"A"	
		movwf	INDF0
		incf	FSR0L,f	

		movlw	"*"	
		movwf	INDF0
		
		clrf	GPStemp1		;Calculate new checksum
		movlw	0x20
		movwf	FSR0H
		movlw	.80;.0
		movwf	FSR0L

BASECreri
		movlw	"*"
		xorwf	INDF0,w
		btfsc	STATUS,Z
		goto	BASECrerend		;Last byte found,exit

		movlw	.200			;End of buffer
		xorwf	FSR0L,w
		btfsc	STATUS,Z
		goto	BASECrerend		
BASECreBend
		movf	INDF0,w
		xorwf	GPStemp1,f		;XOR current byte, increment pointer and loop
		incf	FSR0L,f
		goto	BASECreri
		
BASECrerend	
		incf	FSR0L,f
		movf	GPStemp1,w
		andlw	0x0f			;lower nybble
		movwf	GPSCL
		swapf	GPStemp1,w
		andlw	0x0f			;higher nybble
		movwf	GPSCH
		sublw	.9
		btfsc	STATUS,C
		goto	BASECchk1
		movlw	.55
		goto	BASECchk2
BASECchk1	
		movlw	0x30
BASECchk2		
		addwf	GPSCH,f
		movf	GPSCL,w
		sublw	.9
		btfsc	STATUS,C
		goto	BASECchk11
		movlw	.55
		goto	BASECchk12
BASECchk11	
		movlw	0x30
BASECchk12		
		addwf	GPSCL,f		
		movf	GPSCH,w
		movwf	INDF0
		incf	FSR0L,f
		movf	GPSCL,w
		movwf	INDF0
		incf	FSR0L,f	
		movlw	0xff
		movwf	INDF0			;End marker
		
BASEsend		;Now send the rebuilt string at 9600bps		
		movlw	0x20			;Transmit string
		movwf	FSR0H
		movlw	.80;0x00
		movwf	FSR0L
		call	SERpacket		;Send the string at $0200 data memory
		BANKSEL	PORTA		
		return
		
;--------------------------------------------------------------------------------------------------------		
BLUErelay					;Build the string for base unit and send
;--------------------------------------------------------------------------------------------------------

		movlw	0x20
		movwf	FSR0H
		movlw	.82;0x02
		movwf	FSR0L
		movlw	"P"	
		movwf	INDF0
		incf	FSR0L,f	
		movlw	"S"	
		movwf	INDF0
		incf	FSR0L,f	
		movlw	"U"	
		movwf	INDF0
		incf	FSR0L,f	
		movlw	0x09
		movwf	TempCounP1a		;count ,s
BLUEdecode2					;Now look for the date data
		incf	FSR0L,f
		movlw	","
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BLUEdecode2		;Not the comma, looop
		decfsz	TempCounP1a,f
		goto	BLUEdecode2		;Not the LAST comma, looop
		incf	FSR0L,f	
		
		movlw	"A"	
		movwf	INDF0
		incf	FSR0L,f	

		movlw	"*"	
		movwf	INDF0
		
		clrf	GPStemp1		;Calculate new checksum
		movlw	0x20
		movwf	FSR0H
		movlw	.80;0x00
		movwf	FSR0L

BLUECreri
		movlw	"*"
		xorwf	INDF0,w
		btfsc	STATUS,Z
		goto	BLUECrerend		;Last byte found,exit

		movlw	.200			;End of buffer
		xorwf	FSR0L,w
		btfsc	STATUS,Z
		goto	BLUECrerend		
BLUECreBend
		movf	INDF0,w
		xorwf	GPStemp1,f		;XOR current byte, increment pointer and loop
		incf	FSR0L,f
		goto	BLUECreri
		
BLUECrerend	
		incf	FSR0L,f
		movf	GPStemp1,w
		andlw	0x0f			;lower nybble
		movwf	GPSCL
		swapf	GPStemp1,w
		andlw	0x0f			;higher nybble
		movwf	GPSCH
		
		sublw	.9
		btfsc	STATUS,C
		goto	BLUECchk1
		movlw	.55
		goto	BLUECchk2
BLUECchk1	
		movlw	0x30
BLUECchk2		
		addwf	GPSCH,f
		
		movf	GPSCL,w
		sublw	.9
		btfsc	STATUS,C
		goto	BLUECchk11
		movlw	.55
		goto	BLUECchk12
BLUECchk11	
		movlw	0x30
BLUECchk12		
		addwf	GPSCL,f	
		
		movf	GPSCH,w
		movwf	INDF0
		incf	FSR0L,f
		movf	GPSCL,w
		movwf	INDF0
		incf	FSR0L,f	
		movlw	0xff
		movwf	INDF0			;End marker
		
BLUEsend		;Now send the rebuilt string at 9600bps		
	
		movlw	0x20			;Transmit string
		movwf	FSR0H
		movlw	.80;0x00
		movwf	FSR0L
	
		call	SERpacket		;Send the string at $0200 data memory
		BANKSEL	PORTA		
		
		return
		
;--------------------------------------------------------------------------------------------------------		
MOVErelay					;Build the string for 'movement detected'
;--------------------------------------------------------------------------------------------------------

		movlw	"1"
		movwf	DVAR
		;movlw	"1"
		movwf	DVAR2
		call	SENDrelay
		return
		
;--------------------------------------------------------------------------------------------------------		
SENDrelayHi					;Build the string for PSU-base commands
;--------------------------------------------------------------------------------------------------------
		
		movlw	0x20
		movwf	FSR0H
		movlw	.80;0x00
		movwf	FSR0L
		movlw	"G"	
		movwf	INDF0
		incf	FSR0L,f	
		movlw	"P"	
		movwf	INDF0
		incf	FSR0L,f	
		
		movlw	"P"	
		movwf	INDF0
		incf	FSR0L,f	
		movlw	"S"	
		movwf	INDF0
		incf	FSR0L,f	
		movlw	"U"	
		movwf	INDF0
		incf	FSR0L,f	

		movlw	","	
		movwf	INDF0
		incf	FSR0L,f	
		
		movlw	"0"	
		movwf	INDF0
		incf	FSR0L,f
		movf	DVAR,w	
		movwf	INDF0
		incf	FSR0L,f
		
		movlw	","	
		movwf	INDF0
		incf	FSR0L,f	
		
		movlw	"0"	
		movwf	INDF0
		incf	FSR0L,f
		movf	DVAR2,w	
		movwf	INDF0
		incf	FSR0L,f
		
		movlw	","	
		movwf	INDF0
		incf	FSR0L,f	
		
		movlw	"0"	
		movwf	INDF0
		incf	FSR0L,f
		movf	DVAR2,w	
		movwf	INDF0
		incf	FSR0L,f
		
		movlw	","	
		movwf	INDF0
		incf	FSR0L,f	
		
		movlw	"0"	
		movwf	INDF0
		incf	FSR0L,f
		movf	DVAR2,w	
		movwf	INDF0
		incf	FSR0L,f
		
		movlw	","	
		movwf	INDF0
		incf	FSR0L,f	
		
		movlw	"0"	
		movwf	INDF0
		incf	FSR0L,f
		movf	DVAR2,w	
		movwf	INDF0
		incf	FSR0L,f
		
		movlw	","	
		movwf	INDF0
		incf	FSR0L,f
		
		movlw	"0"	
		movwf	INDF0
		incf	FSR0L,f
		movf	DVAR2,w	
		movwf	INDF0
		incf	FSR0L,f
		
		movlw	","	
		movwf	INDF0
		incf	FSR0L,f	
		
		movlw	"0"	
		movwf	INDF0
		incf	FSR0L,f
		movf	DVAR2,w	
		movwf	INDF0
		incf	FSR0L,f
		
		movlw	","	
		movwf	INDF0
		incf	FSR0L,f	
		
		movlw	"0"	
		movwf	INDF0
		incf	FSR0L,f
		movf	DVAR2,w	
		movwf	INDF0
		incf	FSR0L,f
		
		movlw	","	
		movwf	INDF0
		incf	FSR0L,f	
		
		movlw	"0"	
		movwf	INDF0
		incf	FSR0L,f
		movf	DVAR,w	
		movwf	INDF0
		incf	FSR0L,f
		
		movlw	","	
		movwf	INDF0
		incf	FSR0L,f	

		movlw	"A"	
		movwf	INDF0
		incf	FSR0L,f	

		movlw	"*"	
		movwf	INDF0
		
		clrf	GPStemp1		;Calculate new checksum
		movlw	0x20
		movwf	FSR0H
		movlw	.80;0x00
		movwf	FSR0L

MOVECreri
		movlw	"*"
		xorwf	INDF0,w
		btfsc	STATUS,Z
		goto	MOVECrerend		;Last byte found,exit

		movlw	.200			;End of buffer
		xorwf	FSR0L,w
		btfsc	STATUS,Z
		goto	MOVECrerend		
MOVECreBend
		movf	INDF0,w
		xorwf	GPStemp1,f		;XOR current byte, increment pointer and loop
		incf	FSR0L,f
		goto	MOVECreri
		
MOVECrerend	
		incf	FSR0L,f
		movf	GPStemp1,w
		andlw	0x0f			;lower nybble
		movwf	GPSCL
		swapf	GPStemp1,w
		andlw	0x0f			;higher nybble
		movwf	GPSCH
		
		sublw	.9
		btfsc	STATUS,C
		goto	MOVECchk1
		movlw	.55
		goto	MOVECchk2
MOVECchk1	
		movlw	0x30
MOVECchk2		
		addwf	GPSCH,f
		
		movf	GPSCL,w
		sublw	.9
		btfsc	STATUS,C
		goto	MOVECchk11
		movlw	.55
		goto	MOVECchk12
MOVECchk11	
		movlw	0x30
MOVECchk12		
		addwf	GPSCL,f	
		
		movf	GPSCH,w
		movwf	INDF0
		incf	FSR0L,f
		movf	GPSCL,w
		movwf	INDF0
		incf	FSR0L,f	
		movlw	0xff
		movwf	INDF0			;End marker
		
MOVEsend		;Now send the rebuilt string at 9600bps		
	
		movlw	0x20			;Transmit string
		movwf	FSR0H
		movlw	.80;0x00
		movwf	FSR0L
		call	SERpacket		;Send the string at $0200 data memory
		BANKSEL	PORTA		
		return
		
;--------------------------------------------------------------------------------------------------------		
SERpacket					;Send string pointed at FSR0 to BASEEEupsend
;--------------------------------------------------------------------------------------------------------	
		
		btfsc	INTflags,4		;Check flag for BT data in
		return
		btfsc	INTflags,2		;Check flag for EEPROM in
		return
		BANKSEL	APFCON
		movlw	b'00000000'		;GPS/Base - RXD on ra1,TXD on RA0
		;movlw	b'10000100'		;Bluetooth - RXD on ra5,TXD on RA4
		movwf	APFCON
		
		BANKSEL	BAUDCON			;setup serial 9600bps
		movlw	.206;.103;.26		;2400=103, 9600=26;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		movwf	SPBRGL	

		movlw	.13
		movwf	TXREG
		nop
BASE4a		
		btfsc	INTflags,4		;If a BT packet is incoming drop everything
		return
		btfss	TXSTA,1
		goto	BASE4a
		
		movlw	.10;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;remove in final
		movwf	TXREG
		nop
BASE4s		
		btfsc	INTflags,4		;If a BT packet is incoming drop everything
		return
		btfss	TXSTA,1
		goto	BASE4s
		
		movlw	.60			;Max bytes counter
		movwf  DVAR
		
		movlw	"$"
		movwf	TXREG
		nop
BASE4
		btfsc	INTflags,4		;If a BT packet is incoming drop everything
		return
		btfss	TXSTA,1
		goto	BASE4
		
SERreri
		movlw	0xff
		xorwf	INDF0,w
		btfsc	STATUS,Z
		goto	SERRrerend
		
		movf	INDF0,w
		movwf	TXREG
		nop

SERR5		
		btfsc	INTflags,4		;If a BT packet is incoming drop everything
		return
		btfss	TXSTA,1
		goto	SERR5		
				
		incf	FSR0L,f
		decfsz  DVAR,F			;Overflow trap, max string is 60 bytes
		goto	SERreri
SERRrerend

		BANKSEL	BAUDCON			;setup serial 2400bps
		movlw	.103			;2400=103, 9600=26
		btfss	INTflags,2		;Don't reset baud rate if EE receive active
		movwf	SPBRGL	
		
		BANKSEL	APFCON
		movlw	b'00000000'		;GPS/Base - RXD on ra1,TXD on RA0
		;movlw	b'10000100'		;Bluetooth - RXD on ra5,TXD on RA4
		btfss	INTflags,2		;Don't reset to GPS if EE receive active
		movwf	APFCON
		
		BANKSEL	PORTA
		return
		
;--------------------------------------------------------------------------------------------------------		
BLUpacketHi					;Send string pointed at FSR0 to BLUENOSE AT 1200bps
;--------------------------------------------------------------------------------------------------------
		
		btfsc	INTflags,4		;Check flag for BT data in
		return
		BANKSEL	APFCON
		;movlw	b'00000000'		;GPS/Base - RXD on ra1,TXD on RA0
		movlw	b'10000100'		;Bluetooth - RXD on ra5,TXD on RA4
		btfss	INTflags,2		;Don't reset to GPS if EE receive active
		movwf	APFCON
		
		BANKSEL	BAUDCON			;setup serial 9600bps
		movlw	.26;103			;2400=103, 9600=26
		btfss	INTflags,2		;Don't reset to GPS if EE receive active
		movwf	SPBRGL	
		
		movlw	.60			;Max bytes counter
		movwf  DVAR
		
BLUreri
		movlw	0xff
		xorwf	INDF0,w
		btfsc	STATUS,Z
		goto	BLURrerend
		
		movf	INDF0,w
		movwf	TXREG
		nop
BLUR5		btfss	TXSTA,1
		goto	BLUR5
				
		incf	FSR0L,f
		incf	FSR0L,f
		decfsz	FSR0L,f
		goto	BLUR6
		incf	FSR0H,f
BLUR6
		decfsz  DVAR,F	    		;Overflow trap, max 60 bytes
		goto	BLUreri
BLURrerend
		BANKSEL	BAUDCON			;setup serial 2400bps
		movlw	.103			;2400=103, 9600=26
		btfss	INTflags,2		;Don't reset baud rate if EE receive active
		movwf	SPBRGL	
		
		BANKSEL	APFCON
		movlw	b'00000000'		;GPS/Base - RXD on ra1,TXD on RA0
		;movlw	b'10000100'		;Bluetooth - RXD on ra5,TXD on RA4
		btfss	INTflags,2		;Don't reset to GPS if EE receive active
		movwf	APFCON
		
		BANKSEL	PORTA
		return
;--------------------------------------------------------------------------------------------------------
GPSdecode					;Verify GPS data string and extract time/date
;--------------------------------------------------------------------------------------------------------
		
		clrf	GPStemp1		;Set up registers
		movlw	0x20
		movwf	FSR0H
		movlw	.80;0x00
		movwf	FSR0L

GPSreri
		movlw	"*"
		xorwf	INDF0,w
		btfsc	STATUS,Z
		goto	GPSrerend		;Last byte found,exit

		movlw	.200			;End of buffer
		xorwf	FSR0L,w
		btfsc	STATUS,Z
		goto	GPSrerend		
GPSreBend
		movf	INDF0,w
		xorwf	GPStemp1,f		;XOR current byte, increment pointer and loop
		incf	FSR0L,f
		goto	GPSreri
GPSrerend
		incf	FSR0L,f
		incf	FSR0L,f			;Increment to LSB of checksum
		movf	INDF0,w
		sublw	0x40			;Subtract 0x40 - will overflow if it's a number
		btfsc	STATUS,C
		goto	GPSmsblo1		;Yes, it's a number
		movlw	.55			;It's a letter, A-F
		subwf	INDF0,w
		goto	GPSrerend1
GPSmsblo1
		movlw	0x30
		subwf	INDF0,w		
GPSrerend1
		andlw	0x0f
		movwf	GPSpoint
		swapf	GPSpoint,f		;Swap to high nibble
		decf	FSR0L,f			;Get MSB
		movf	INDF0,w
		sublw	0x40			;Subtract 0x40 - overflow?
		btfsc	STATUS,C
		goto	GPSmsblo2		;Yes, it's a number
		movlw	.55
		subwf	INDF0,w
		goto	GPSmsblo2a
GPSmsblo2
		movlw	0x30
		subwf	INDF0,w
GPSmsblo2a
		andlw	0x0f
		iorwf	GPSpoint,f		;Add both nibbles
		swapf	GPSpoint,f		;and swap the right way round

		movf	GPSpoint,w		;Compare checksums
		xorwf	GPStemp1,w
		btfss	STATUS,Z

		goto	GPSdecodeXtra		;Bytes don't match, maybe a BT string?

;We have a valid string, now extract the data we need from it
;$GPRMC,092751.000,A,5321.6802,N,00630.3371,W,0.06,31.66,280511,,,A*45		
;$GPRMC,232224,,,,,,,,171116,A*0C
GPSdecodeOK					;Bytes do match, it's GPS data
		movlw	.82;0x02
		movwf	FSR0L
		movlw	"R"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	GPSdecodeXtra		;Not the string we want, exit
		incf	FSR0L,f
		movlw	"M"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	GPSdecodeXtra		;Not the string we want, exit
		incf	FSR0L,f
		movlw	"C"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	GPSdecodeXtra		;Not the string we want, exit
		incf	FSR0L,f	
		bsf	PORTA,2			;Flag valid by flashing LED2
		call	GPSNAMEsend		;Tell bluetooth we have a valid GPRMC packet
		bcf	PORTA,2			
	
GPSdecodesend		
		call	BASErelay		;Code send here

GPSdecodeXHi					;Exit point
		bcf	INTflags,7		;Clear check if GPS data received
		bsf	INTCON,IOCIE		;enable IOCs for next BT packet
		BANKSEL	PORTA	
		return		
		
GPSdecodeXtra
		;Check for EEPROM commands, if not pass it to the BT command forwarder
		
		movlw	.82;0x02
		movwf	FSR0L
				
		movlw	"E"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BlueDecode		;Not the string we want, exit
		incf	FSR0L,f
		movlw	"e"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BlueDecode		;Not the string we want, exit
		incf	FSR0L,f
		movlw	"p"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BlueDecode		;Not the string we want, exit
		incf	FSR0L,f
		movlw	"R"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BlueDecodeXtra		;Not the string we want, exit
		incf	FSR0L,f
		movlw	"o"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BlueDecodeXtra		;Not the string we want, exit
		incf	FSR0L,f
		movlw	"M"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BlueDecodeXtra		;Not the string we want, exit
		bsf	PORTA,2			;Flag valid by flashing LED2
		bsf	INTflags,2		;Set eeprom receive mode entered
		goto	FirmUp
		
BlueDecodeXtra					;Part string match 'Eep', check if it's burn

		movlw	"I"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BlueDecode		;Not the string we want, exit
		incf	FSR0L,f
		movlw	"d"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BlueDecode		;Not the string we want, exit
		bsf	PORTA,2			;Flag valid by flashing LED2
		goto	BurnID
					
;--------------------------------------------------------------------------------------------------------		
BlueDecode					;Extra command decode for GPS/BT in - exit by GOTOs
;--------------------------------------------------------------------------------------------------------
	
		movlw	.82;0x02
		movwf	FSR0L
		movlw	"B"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BlueDecodeX		;Not the string we want, exit
		incf	FSR0L,f
		movlw	"L"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BlueDecodeX		;Not the string we want, exit
		incf	FSR0L,f
		movlw	"U"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BlueDecodeX		;Not the string we want, exit
		incf	FSR0L,f	
		movlw	","
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BlueDecodeX		;Not the string we want, exit
		incf	FSR0L,f
		movlw	"0"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BlueDecodeX		;Not the string we want, exit
		incf	FSR0L,f	
	
		movlw	"1"
		xorwf	INDF0,w
		btfsc	STATUS,Z		;NOTE:reject string if this digit is '1'
		goto	BlueDecodeX		;Not the string we want, exit
		
		movlw	"9"
		xorwf	INDF0,w
		btfsc	STATUS,Z		;NOTE:reject string if this digit is '9'
		goto	BlueDecodeX		;Not the string we want, exit
		
		incf	FSR0L,f	
			
		movlw	0x08
		movwf	TempCounP1a		;count ,s
BLUEdecodeloop					;Now look for the date data
		incf	FSR0L,f
		movlw	","
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BLUEdecodeloop		;Not the comma, looop
		decfsz	TempCounP1a,f
		goto	BLUEdecodeloop		;Not the LAST comma, looop
		incf	FSR0L,f	
		
		movlw	"N"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BlueDecodeX		;Not the string we want, exit
		incf	FSR0L,f
		movlw	"O"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BlueDecodeX		;Not the string we want, exit
		incf	FSR0L,f
		movlw	"S"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BlueDecodeX		;Not the string we want, exit
		incf	FSR0L,f			
		movlw	"E"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	BlueDecodeX		;Not the string we want, exit
		incf	FSR0L,f			
		bsf	PORTA,2			;Flag valid by flashing LED2
		call	BlueNAMEsend		;Tell bluetooth we have a valid GPRMC packet
		bcf	PORTA,2			
			
		call	BLUErelay		;Code send here
BlueDecodeX	
		bcf	INTflags,2		;Clear eeprom receive mode
		bcf	PORTA,2					
		goto	GPSdecodeX		;EXIT
		
;--------------------------------------------------------------------------------------------------------
BLUsendHi						;Set bluetooth module name		
;--------------------------------------------------------------------------------------------------------
	
		movlw	HIGH BTname		;Transmit string
		movwf	FSR0H
		movlw	LOW BTname
		movwf	FSR0L
		call	BLUpacket		;Send BT ID string		
		return
BTname
	dt  0x0d,0x0a,"AT+NAMEFruit Flies",0x0d,0x0a,0xff	;Bluetooth module name string
		
;--------------------------------------------------------------------------------------------------------
GPSNAMEsend					;Send GPS received		
;--------------------------------------------------------------------------------------------------------
	
		movlw	HIGH GPSname		;Transmit string
		movwf	FSR0H
		movlw	LOW GPSname
		movwf	FSR0L
		call	BLUpacket		;Send string
		return
GPSname
	dt  0x0d,0x0a,"GPS mouse time signal received",0xff	;GPS detected string
	
;--------------------------------------------------------------------------------------------------------		
BlueNAMEsend					;Send 'Bluetooth packet received'
;--------------------------------------------------------------------------------------------------------
		
		movlw	HIGH Bluesend		;Transmit string
		movwf	FSR0H
		movlw	LOW Bluesend
		movwf	FSR0L
		call	BLUpacket		;Send string
		return
Bluesend
	dt  0x0d,0x0a,"Bluetooth packet received",0xff	;BT packet detected string
	
;--------------------------------------------------------------------------------------------------------		
EEupNAMEsend					;Send 'EEPROM start received'
;--------------------------------------------------------------------------------------------------------
		
		movlw	HIGH EEupsend		;Transmit string
		movwf	FSR0H
		movlw	LOW EEupsend
		movwf	FSR0L
		call	BLUpacket		;Send string
		return
EEupsend
	dt  0x0d,0x0a,"EEPROM update mode initialised",0xff	    ;EEPROM update end string
		
;--------------------------------------------------------------------------------------------------------		
EEpsuNAMEsend					;Send 'power supply'
;--------------------------------------------------------------------------------------------------------
		
		movlw	HIGH EEPSUsend		;Transmit string
		movwf	FSR0H
		movlw	LOW EEPSUsend
		movwf	FSR0L
		call	BLUpacket		;Send string
		return
EEPSUsend
	dt  0x0d,0x0a,"Power supply image",0xff	;EEPROM for PSU received
	
;--------------------------------------------------------------------------------------------------------		
EEbaseNAMEsend					;Send 'base unit'
;--------------------------------------------------------------------------------------------------------
		
		movlw	HIGH EEBASEsend		;Transmit string
		movwf	FSR0H
		movlw	LOW EEBASEsend
		movwf	FSR0L
		call	BLUpacket		;Send string
		return
EEBASEsend
	dt  0x0d,0x0a,"Base unit image",0xff	;EEPROM for base received
		
;--------------------------------------------------------------------------------------------------------		
EEclockNAMEsend					;Send 'clock module'
;--------------------------------------------------------------------------------------------------------
		
		movlw	HIGH EERELsend		;Transmit string
		movwf	FSR0H
		movlw	LOW EERELsend
		movwf	FSR0L
		call	BLUpacket		;Send string
		return
EERELsend
	dt  0x0d,0x0a,"Clock module image",0xff	;EEPROM for relay received
	
;--------------------------------------------------------------------------------------------------------		
CKNAMEsend					;Send 'Checksum OK'
;--------------------------------------------------------------------------------------------------------
		
		movlw	HIGH CKsend		;Transmit string
		movwf	FSR0H
		movlw	LOW CKsend
		movwf	FSR0L
		call	BLUpacket		;Send string
		return
CKsend
	dt  0x0d,0x0a,"Checksum OK",0xff	    ;EEPROM update end string
		
;--------------------------------------------------------------------------------------------------------		
CKFNAMEsend					;Send 'Checksum failed'
;--------------------------------------------------------------------------------------------------------
		
		movlw	HIGH CKFsend		;Transmit string
		movwf	FSR0H
		movlw	LOW CKFsend
		movwf	FSR0L
		call	BLUpacket		;Send string
		return	
CKFsend
	dt  0x0d,0x0a,"Checksum failed",0xff	    ;EEPROM update end string
		
;--------------------------------------------------------------------------------------------------------		
EEsendNAMEsend					;Send 'Sending to Base'
;--------------------------------------------------------------------------------------------------------
		
		movlw	HIGH EEsendsend		;Transmit string
		movwf	FSR0H
		movlw	LOW EEsendsend
		movwf	FSR0L
		call	BLUpacket		;Send string
		return			
EEsendsend
	dt  0x0d,0x0a,"Sending firmware to Base unit",0xff
	
;--------------------------------------------------------------------------------------------------------		
EEIDDUDsendNAME					;Send 'EEPROM image recognised'
;--------------------------------------------------------------------------------------------------------
		
		movlw	HIGH EEIDDUDsend		;Transmit string
		movwf	FSR0H
		movlw	LOW EEIDDUDsend
		movwf	FSR0L
		call	BLUpacket		;Send string
		return	
EEIDDUDsend
	dt  0x0d,0x0a,"Unidentified EEPROM",0xff
	
;#####################################################################################################################################

		end

;#####################################################################################################################################
